// $Id: PacketVisualizationCanvas.java,v 1.4 2001/05/28 18:20:19 pcharles Exp $

/***************************************************************************
 * Copyright (C) 2001, Patrick Charles and Jonas Lehmann                   *
 * Distributed under the Mozilla Public License                            *
 *   http://www.mozilla.org/NPL/MPL-1.1.txt                                *
 ***************************************************************************/
package net.sourceforge.jpcap.client;

import java.util.Iterator;
import java.util.HashSet;
import java.util.HashMap;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Canvas;


/**
 * A graphical view of captured packets.
 *
 * @author Patrick Charles and Jonas Lehmann
 * @version $Revision: 1.4 $
 * @lastModifiedBy $Author: pcharles $
 * @lastModifiedAt $Date: 2001/05/28 18:20:19 $
 */
public class PacketVisualizationCanvas extends Canvas
{
  /**
   * Create a new packet visualization canvas.
   */
  public PacketVisualizationCanvas(HashMap hostMap, HashMap commMap) {
    super();

    this.hostMap = hostMap;
    this.commMap = commMap;

    setBackground(Color.black);
  }

  public int getWidth() {
    return width;
  }

  public int getHeight() {
    return height;
  }

  public HashMap getHostMap() {
    return hostMap;
  }

  public HashMap getCommMap() {
    return commMap;
  }

  /**
   * Repaint all the hosts and communications on this canvas.
   */
  public void paint(Graphics g) {
    super.paint(g);

    // todo: this sucks
    CommRenderer.slots.clear();

    // only update Component's height and width on repaints.
    width = super.getWidth();
    height = super.getHeight();

    Iterator hIterator = hostMap.values().iterator();
    while(hIterator.hasNext()) {
      HostRenderer hs = (HostRenderer)hIterator.next();
      hs.paint();
    }

    Iterator cIterator = commMap.values().iterator();
    while(cIterator.hasNext()) {
      CommRenderer cs = (CommRenderer)cIterator.next();
      cs.paint();
    }
  }


  /**
   * host renderers drawing on this canvas.
   */
  HashMap hostMap;

  /**
   * communication renderers drawing on this canvas.
   */
  HashMap commMap;


  int width;
  int height;

  private String _rcsid = 
    "$Id: PacketVisualizationCanvas.java,v 1.4 2001/05/28 18:20:19 pcharles Exp $";
}
