// $Id: IPAddress.java,v 1.2 2001/06/01 06:31:44 pcharles Exp $

/***************************************************************************
 * Copyright (C) 2001, Patrick Charles and Jonas Lehmann                   *
 * Distributed under the Mozilla Public License                            *
 *   http://www.mozilla.org/NPL/MPL-1.1.txt                                *
 ***************************************************************************/
package net.sourceforge.jpcap.net;


/**
 * IP address.
 * <p>
 * This class doesn't store IP addresses. There's a java class for that,
 * and it is too big and cumbersome for our purposes.
 * <p>
 * This class contains a utility method for extracting an IP address 
 * from a big-endian byte array.
 *
 * @author Patrick Charles and Jonas Lehmann
 * @version $Revision: 1.2 $
 * @lastModifiedBy $Author: pcharles $
 * @lastModifiedAt $Date: 2001/06/01 06:31:44 $
 */
public class IPAddress
{
  /**
   * Extract an IP address from an array of bytes.
   *
   * @param offset the offset of the address data from the start of the 
   * packet.
   * @param bytes an array of bytes containing one or more IP addresses.
   */
  public static String extract(int offset, byte [] bytes) {
    StringBuffer sa = new StringBuffer();
    for(int i=offset; i<offset + WIDTH; i++) {
      sa.append(0xff & bytes[i]);
      if(i != offset + WIDTH - 1)
        sa.append('.');
    }
    return sa.toString();
  }


  /**
   * The width in bytes of an IP address.
   */
  public final static int WIDTH = 4;

  private String _rcsid = 
    "$Id: IPAddress.java,v 1.2 2001/06/01 06:31:44 pcharles Exp $";
}
